import 'dart:async';

/// Instanciate this class to debounce a task.
/// In this example, 'Hi!' is only printed once:
/// ```dart
/// final debouncer = Nexbounce();
///
/// debouncer.enqueue(() => print('Hi!'));
/// debouncer.enqueue(() => print('Hi!'));
/// ```
class Nexbounce {
  Timer? _timer;

  /// Accepts a function as its argument to be debounced.
  void enqueue(final void Function() task) {
    _timer?.cancel();
    _timer = Timer(Duration.zero, task);
  }
}
